%{ /* -*- text-mode -*- */

/* we pass a pointer to the painter into the  */
#define YYPARSE_PARAM p

#include "icon.hh"

#define PROGRAM	((IconProgram *)p)
int redidx, greenidx, blueidx ;

int bufSize = 2 ; // first 2 taken by instruction code and size
		   // 
int bufAlloc = 160 ;
short int *buffer = new short int[bufAlloc] ;


%}	

%token NUMBER
%token SETBRUSH SETPEN FILLPOLY LINEPOLY
%token COLOUR_DEFAULT COLOUR_SHADOW COLOUR_OUTLINE
%token RIGHT_B LEFT_B COMMA
%%

list		:  /* empty */
		|  list directive
		;

directive	:  SETBRUSH COLOUR_DEFAULT	
			{ PROGRAM->addInstruction (IconProgram::brush_iconcolour) ; }
		|  SETPEN COLOUR_DEFAULT		
			{ PROGRAM->addInstruction (IconProgram::pen_iconcolour) ; }	
		|  SETBRUSH COLOUR_SHADOW
			{ PROGRAM->addInstruction (IconProgram::brush_shadowcolour) ; }
		|  SETPEN COLOUR_SHADOW
			{ PROGRAM->addInstruction (IconProgram::pen_shadowcolour) ; }
		|  SETBRUSH COLOUR_OUTLINE
			{ PROGRAM->addInstruction (IconProgram::brush_outlinecolour) ; }
		|  SETPEN COLOUR_OUTLINE
			{ PROGRAM->addInstruction (IconProgram::pen_outlinecolour) ; }
		|  SETPEN LEFT_B NUMBER NUMBER NUMBER RIGHT_B
			{ short int cols[4] ;
			  cols[0] = IconProgram::pen_colour ;
			  cols[1] = $3 ; cols[2] = $4 ; cols[3] = $5 ;
			  PROGRAM->addInstruction (cols, 4) ;
			}
		|  SETBRUSH LEFT_B NUMBER NUMBER NUMBER RIGHT_B
			{ short int cols[4] ;
			  cols[0] = IconProgram::brush_colour ;
			  cols[1] = $3 ; cols[2] = $4 ; cols[3] = $5 ;
			  PROGRAM->addInstruction (cols, 4) ;
			}
		|  FILLPOLY LEFT_B vertexlist RIGHT_B
			{ buffer[0] = IconProgram::fillpoly ;
			  buffer[1] = bufSize - 2 ; 
			  PROGRAM->addInstruction (buffer, bufSize) ;
			  bufSize = 2 ; // reset
			}
		|  LINEPOLY LEFT_B vertexlist RIGHT_B
			{ buffer[0] = IconProgram::linepoly ;
			  buffer[1] = bufSize - 2 ; 
			  PROGRAM->addInstruction (buffer, bufSize) ;
			  bufSize = 2 ; // reset
			}
		;

vertexlist	: vertex
		| vertex COMMA vertex
		| vertex COMMA vertexlist
		;

vertex		: NUMBER NUMBER
			{ buffer[bufSize++] = $1 ;
			  buffer[bufSize++] = 96 - $2 ; // coor system is upside down
			  if (bufSize > bufAlloc)
				debug ("Need more verts in parser") ;
			}
		;

%%

int yyerror (char *s)
{
	debug ("parser: %s",s) ;
	return 0 ;
}
